import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.awt.image.*;
import java.io.File;
import javax.imageio.ImageIO;

public class ControlCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener,KeyListener {
    Manager M;
    AffineTransform A;
    Complex SOURCE;
    Complex RIVAL;
    Color COLOR;
    double DIST;
    ListenSquare CONTROL;
    ControlPanel DISPLAY,CLOSE;
    SelectInteger DEV;
    Point JX;
    boolean PRESS;   
    ListenSquare ROT,GO,STOP;
    PopupManager PM;
    ListenSquare INFO1,INFO2,INFO3,INFO4,INFO5;
    ListenSquare[] INFO=new ListenSquare[8];
    Animate AN;


     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(280,365,105);
	 SOURCE=new Complex(0,0);
	 CONTROL=new ListenSquare(0,0,599,80);
	 DEV=new SelectInteger(5,150,40,20,0,0,6,1);
	 INFO1=new ListenSquare(70,150,13,12);
	 INFO2=new ListenSquare(0,145,12,12);
	 INFO3=new ListenSquare(105,230,12,12);
	 INFO4=new ListenSquare(160,195,12,12);
	 INFO5=new ListenSquare(0,190,12,12);
	 for(int i=0;i<8;++i) INFO[i]=new ListenSquare(117,20+15*i,13,13);

	 DIST=0;
	 PRESS=false;    
	 Point JX=new Point(0,0);
	 setPanels();
	 GO=new ListenSquare(160,210,25,20);
	 STOP=new ListenSquare(185,210,40,20);
	 Tilt.R=0;
	 PM=new PopupManager(this.M,0,189);
	 AN=new Animate();
     }


    public void setPanels() {
	Color[] C0={new Color(0,0,100),Color.white,
		    Color.white,Color.white,new Color(0,255,255)};

	Color[] C1={new Color(20,40,60),Color.white,
		    Color.white,Color.white,new Color(0,255,255)};


	String[] DisplayString={"map construction","spider","cut locus","voronoi images ","voronoi construct","barycentric sub","J curve","map","picture display"};
	int[] DisplayState={0,0,0,0,0,1,1,1};
  DISPLAY=new ControlPanel(C1,DisplayString,DisplayState,8);


  String[] CloseString={"map construction","barycentric sub","J curve","map","remote display"};
  int[] CloseState={1,1,1,1};
  CLOSE=new ControlPanel(C0,CloseString,CloseState,4);

    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawControls(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(0,80,80));
	g.fillRect(0,0,getWidth(),getHeight());
	g.setColor(new Color(80,0,0));
	g.fillRect(0,190,getWidth(),getHeight());
	g.setColor(Color.white);
	g.drawRect(0,190,getWidth(),getHeight());
    }

    public void drawControls(Graphics2D g) {
	g.setColor(new Color(255,190,0));
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
        g.drawString("animate",176,204);
        g.setFont(new Font("Helvetica",Font.PLAIN,13));
	g.setColor(Color.white);
	if(AN.HALT==true) {
            GO.render(g,new Color(0,180,0));
            g.drawString("go",164,226);
	}
	if(AN.HALT==false) {
	   STOP.render(g,Color.red);
           g.drawString("stop",189,226);
	}

	if(DISPLAY.L[4].on==1) {
	    DEV.render(g,new Color(0,200,0),Color.white,Color.white);
	   INFO1.infoRender(g);
	    g.drawString("triangle choice",5,182);
	}


	g.setColor(new Color(255,190,0));
        g.setFont(new Font("Helvetica",Font.PLAIN,13));
	g.drawString("keyboard", 75,210);
	g.drawString("command", 75,225);
	g.drawString("info:", 75,240);

	DISPLAY.render(g,0,0,130);
	CLOSE.render(g,167,60,133);
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.setColor(Color.white);
	g.drawRect(0,0,getWidth()-1,getHeight()-1);
	PM.render(g);

	g.setColor(new Color(80,0,0));
	g.fillRect(168,0,131,45);
	g.setColor(Color.white);
	g.drawRect(168,0,131,45);
        g.setFont(new Font("Papyrus",Font.PLAIN,15));
	g.setColor(new Color(255,190,0));
	g.drawString("Spider's Embrace",173,16);
	g.drawString("Rich Schwartz",173,40);

	for(int i=0;i<8;++i) INFO[i].infoRender(g);
	INFO3.infoRender(g);
	INFO4.infoRender(g);
	INFO5.infoRender(g);


    }





    public void doGo() {
	if(AN.HALT==false) return;
	AN=new Animate(this.M);
	new Thread(AN).start();
    }


  public void mouseEntered(MouseEvent e) {
      requestFocus();
   }

   public void mouseClicked(MouseEvent e) { 
       MouseData J=MouseData.process(e);
       doMouseClick(J.X,J.mode);
   }

   public void mouseMoved(MouseEvent e) {
       MouseData J=MouseData.process(e);
   }


    public void documentStuff(Point X) {

	if(INFO1.inside(X)==1) DocumentControl.dev(M.D);
	if(INFO2.inside(X)==1) DocumentControl.web(M.D);
	if(INFO3.inside(X)==1) DocumentControl.key(M.D);
	if(INFO4.inside(X)==1) DocumentControl.animate(M.D);
	if(INFO5.inside(X)==1) DocumentControl.popup(M.D);

	if(INFO[0].inside(X)==1) DocumentControl.mapGuides(M.D);
	if(INFO[1].inside(X)==1) DocumentControl.spider(M.D);
	if(INFO[2].inside(X)==1) DocumentControl.cutLocus(M.D);
	if(INFO[3].inside(X)==1) DocumentControl.voronoiImages(M.D);
	if(INFO[4].inside(X)==1) DocumentControl.voronoi(M.D);
	if(INFO[5].inside(X)==1) DocumentControl.bary(M.D);
	if(INFO[6].inside(X)==1) DocumentControl.curves(M.D);
	if(INFO[7].inside(X)==1) DocumentControl.map(M.D);
    }

    
    public void doMouseClick(Point X,int mode) {
	PM.M=this.M;
	PM.process(X);
	if(GO.inside(X)==1) doGo();
	if(STOP.inside(X)==1) AN.HALT=true;
	DEV.modifyCyclic(X);
	documentStuff(X);
	int test=DISPLAY.toggle(X);
	if(test==20) DocumentControl.display(M.D);
	test=CLOSE.toggle(X);
	if(test==20) DocumentControl.closeup(M.D);
        M.repaint();
    }
    
    public void mouseDragged(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {

    }

     public void mouseReleased(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


    public void keyTyped(KeyEvent e) {}

 
    public void keyPressed(KeyEvent e) {
    }
    public void keyReleased(KeyEvent e) {
	PRESS=false;
    }

}

