import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**Documentation file*/


public class DocumentIntro {

    public DocumentIntro() {}


    public static void setup(DocumentCanvas D) {
    
	String S="Spider's Embrace";
        S=S+"\nby Rich Schwartz";


	S=S+"\n\nPURPOSE:\n\n";
	S=S+"The purpose of this program is to illustrate the structure of the antifarpoint (AF) map on the regular octahedron. AF is the composition, in either order, of the antipodal map and the farpoint map F.   Here F(p) is the point on the regular octahedron farthest from p.  Generically this point is unique.";

	    S=S+"\n\nOPERATING INSTRUCTIONS";

	    S=S+"\n\nThis program has 5 windows.\n\n0. Control panel.  The small and colorful window controls the rest of the program. If you kill this window, the whole program stops.\n\n1. Info: The window with this text gives instructions for and information about the rest of the program. You can drag the text to scroll up and down.  If you click on the blue question (?) boxes scattered throughout the control panel, this window will show text which explains the relevant feature.  If you click the blue ?-box at the top of this window, it will return the text you are reading now. \n\n2. Picture window.  This is the main window.  It illustrates AF.\n\n3. Closeup window: This lets you remotely control the picture window. As you explore the program you will see that sometimes this is a nice feature to have.\n\n4. Color scheme window.  This lets you change the various colors in the program.";

            S=S+"\n\nExcept for the control panel, the rest of the windows are killable and resurrectable. You bring up these other windows by clicking on the buttons on the lower left part of the control panel (the popups console) and you kill them in the usual way you kill windows on your computer.  Try bringing up the picture window, killing it, and then resurrecting it. You can also resize these popup windows in the usual way that you resize windows on your computer. The ?-box by the popups console has more info on how to do all this.";

	    S=S+"\n\nThis program is designed to work best with a 3 button mouse. On the picture and closeup windows, buttoms 1 and 3 zoom in and out of the picture and button 2 selects a new point.  You can also drag button-2 to continuously select a new point. If you don't have a 3 button mouse, click the ?-box which gives info about keyboard commands.  This will tell you how to use the keyboard in place of a 3-button mouse.";

	    S=S+"\n\nGRAPHICAL CONVENTIONS:";

	    S=S+"\n\nAll the action takes place in the plane.  What we are drawing in the picture window is part of the development of the regular octahedron into the plane. The central triangle is the triangle of interest, the domain of AF.  The colorful triangles are the development images of the antipodal triangle on the octahedron.  These colorful triangles have been partitioned into smaller polygons.  These smaller polygons are essentially complements of the cut locus of the far triangle w.r.t. the point chosen in the central triangle.  AF is determined by the structure of the cut locus, and symmetry.  This program lets you explore this structure.";


	    S=S+"\n\nGETTING STARTED";

	    S=S+"\n\nOpen up the picture window. Then drag the mouse over the central black triangle of the picture window.  This will show you the action of the AF.  (You can also just press th green GO button on the control panel and watch an animation which selects points for you.)  The point p is connected to AF(p) by a line segment. You can see how AF changes as you cross the various DDs.  The straight line foliation is not drawn but you can probably see that it is there by comparing p and AF(p).";

	    S=S+"\n\nAs you drag the mouse around, you can see some auxiliary large parallelograms appear, as well as some auxiliary lines.  These various objects show you how AF is defined within the given DD.  In each of the 12 domains these various auxiliary structures remain the same, and the map varies birationally.  When you cross into a different DD, these structures change.  You can get the feel for how things change as you sample all 12 DDs.";

	    S=S+"\n\nLEARNING THE STRUCTURE";

	    S=S+"\n\nThis program displays all the structure associated to AF.  You can learn about this structure by clicking on the ?-box associated to the picture window display.  As you read about the feature, try experimenting around until it makes sense to you.";

	    S=S+"\n\nFINAL CONCLUSIONS";

	    S=S+"\n\n1. AF preserves each of the 8 triangular faces of the regular octahedron.\n\n2. Within each triangular face, AF is a piecewise birational map, with 12 domains of definition (DD) where it is entirely defined and birational.  The guides ?-box explains the precise definition of the map.\n\n3. Each of the 12 DDs is forward invariant and has an AF-invariant foliation by half-open line segments.\n\n4. The restriction of AF to each line segment coincides with a real projective transformation.\n\n5.The open endpoints of the invariant line segments lie in certain algebraic curves where AF is not uniquely defined.  The curves ?-box gives a formula for these curves.\n\n6.The closed endpoints are attracting fixed points and lie in the 1-skeleton of the first barycentric subdivision of the octahedron.\n\n7. (Therefore) the omega limit set of AF is contained in the 1-skeleton of the barycentric subdivision of the regular octahedron.  ";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }
}

