import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This class produces the vertices of the cut locus*/

public class Voronoi  {
    ControlCanvas C;


    /**This is the main routine.
       The point z is the source point*/
    

    public static Complex[] candidates(Complex z,int k) {
	Complex[] Z=candidatesExtended(z);
	int count=0;
	int n=Z.length;
	Complex[] W=new Complex[n];
	for(int i=0;i<n;++i) {
	    if(Octahedron.isShort(z,Octahedron.fix(Z[i]),k)==true) {
		W[count]=new Complex(Z[i]);
		++count;
	     }
	}
	Complex[] W1=new Complex[count];
	for(int i=0;i<count;++i) W1[i]=W[i];
	return(W1);
    }


    public static Complex[] candidatesExtended(Complex z) {  
        Path2D.Double gp=Triangulation.triFat(2,1,1);
	Complex[][] W=bisectorListExtended(z);
	int count=0;
	int n=W.length;
	Complex[] X=new Complex[n*(n-1)/2];
	for(int i=0;i<n;++i) {
	  for(int j=i+1;j<n;++j) {
	      Complex w=Octahedron.getIntersection(W[i],W[j]);

	      if(gp.contains(w.x,w.y)==true) {
		  X[count]=new Complex(w);
		  ++count;
	      }
	  }
	}
	Complex[] X2=new Complex[count];
	for(int i=0;i<count;++i) X2[i]=X[i];
	return(X2);
    }



    public static Complex[][] bisectorListExtended(Complex z) {
	double s3=Math.sqrt(3);
	Complex[][] W0=Octahedron.bisectorList(z);
	Complex[][] W=new Complex[15][2];
	for(int i=0;i<12;++i) {
	    W[i][0]=new Complex(W0[i][0]);
	    W[i][1]=new Complex(W0[i][1]);
	}
	W[12][0]=new Complex(1,s3);
	W[12][1]=new Complex(2.5,s3/2);
	W[13][0]=new Complex(2.5,s3/2);
	W[13][1]=new Complex(2.5,3*s3/3);
	W[14][0]=new Complex(2.5,3*s3/2);
	W[14][1]=new Complex(1,s3);

	return(W);
    }

}


